{%- comment -%}

########## image.html ##########
This template allows you to easily include a responsive image on a page. It
will automatically generate a srcset with various sizes of the image for all
viewport sizes, and pixel densities of up to 3x. The logic for this template
is a bit convoluted, mostly because I tried to check for a bunch of different
possible image widths to make sure we weren't generating image files wider
than the source file.

##### Parameters #####
src: Required. The filename of the image, which must be placed in the
    `_assets/img/` directory.

alt: Text to be used as the alt text for the img tag (the browser typically
    shows this text if the image fails to load).

caption: A caption to be shown below the image. Markdown is supported for this
    field.

type: Valid values are 'focus' (default), 'focus-small', 'left', or 'right'. A
    focus type image will be large, centered, and not allow text beside it. A
    focus-small type image will be similar, but not quite as large. A left/right
    type image will be smaller, aligned to the side, and will allow text to
    appear beside it.

no_thumbnail: If set to true, there will be no border around the image.

class: Additional CSS class (or classes, space-delimited) to add to the img tag.
    If you don't know what that means, don't use this.

itemprop: The item property for this image in microdata. If you don't know what
    that means, don't use this.

##### Usage #####
Simplest version:
    {% include image.html src='my-image.jpg' %}

With alt text and a caption:
    {% include image.html src='my-image.jpg'
      alt='A man speaking in front of a computer'
      caption='A.J. leading a meeting' %}

{%- endcomment -%}


{%- assign src = include.src -%}
{%- assign type = include.type | default: 'focus' | strip_html | strip -%}

{%- capture classes -%}
  {%- unless include.no_thumbnail %}img-thumbnail{%- endunless -%}
  {%- if include.class -%}{{- ' ' | append: include.class | strip_html -}}{%- endif -%}
{%- endcapture -%}

{%- capture alt -%}
  {{- include.alt | strip_html -}}
{%- endcapture -%}

<figure class="post-img post-img-{{ type }}" {% if include.itemprop %}itemprop="{{ include.itemprop }}" {% endif %}itemscope itemtype="http://schema.org/ImageObject">
  <a href="{% asset '{{ src }}' @path %}" target="_blank" itemprop="url contentUrl">
    {% if assets[src].content_type == "image/svg+xml"
      or assets[src].width <= 384
      or jekyll.environment == "development"
      -%}
      {%- asset '{{ src }}' !integrity
        alt="{{ alt }}" class="{{ classes }}" itemprop=thumbnailUrl
        -%}

    {%- elsif assets[src].width <= 576 -%}
      {%- asset '{{ src }}' !integrity
        srcset:width='{{ assets[src].width }}'
        srcset:width=384
        alt="{{ alt }}" class="{{ classes }}" itemprop=thumbnailUrl
        -%}

    {%- elsif assets[src].width <= 768 -%}
      {%- asset '{{ src }}' !integrity
        srcset:width='{{ assets[src].width }}'
        srcset:width=576
        srcset:width=384
        alt="{{ alt }}" class="{{ classes }}" itemprop=thumbnailUrl
        -%}

    {%- elsif assets[src].width <= 1536 -%}
      {%- asset '{{ src }}' !integrity
        srcset:width='{{ assets[src].width }}'
        srcset:width=768
        srcset:width=576
        srcset:width=384
        alt="{{ alt }}" class="{{ classes }}" itemprop=thumbnailUrl
        -%}

    {%- elsif assets[src].width <= 2304 -%}
      {%- asset '{{ src }}' !integrity
        srcset:width='{{ assets[src].width }}'
        srcset:width=1536
        srcset:width=768
        srcset:width=576
        srcset:width=384
        alt="{{ alt }}" class="{{ classes }}" itemprop=thumbnailUrl
        -%}

    {%- else -%}
      {%- asset '{{ src }}' !integrity
        srcset:width=2304
        srcset:width=1536
        srcset:width=768
        srcset:width=576
        srcset:width=384
        alt="{{ alt }}" class="{{ classes }}" itemprop=thumbnailUrl
        -%}

    {%- endif %}
  </a>
  {% if include.caption -%}
    <figcaption itemprop="caption">
      {{- include.caption | markdownify -}}
    </figcaption>
  {%- endif %}
</figure>
